Index: uspace/lib/ui/src/menu.c
===================================================================
--- uspace/lib/ui/src/menu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/menu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -35,4 +35,5 @@
 
 #include <adt/list.h>
+#include <ctype.h>
 #include <errno.h>
 #include <gfx/color.h>
@@ -43,4 +44,7 @@
 #include <stdlib.h>
 #include <str.h>
+#include <uchar.h>
+#include <ui/ui.h>
+#include <ui/accel.h>
 #include <ui/control.h>
 #include <ui/paint.h>
@@ -50,5 +54,4 @@
 #include <ui/resource.h>
 #include <ui/window.h>
-#include "../private/menubar.h"
 #include "../private/menu.h"
 #include "../private/resource.h"
@@ -63,8 +66,11 @@
 
 static void ui_menu_popup_close(ui_popup_t *, void *);
+static void ui_menu_popup_kbd(ui_popup_t *, void *, kbd_event_t *);
 static void ui_menu_popup_pos(ui_popup_t *, void *, pos_event_t *);
+static void ui_menu_key_press_unmod(ui_menu_t *, kbd_event_t *);
 
 static ui_popup_cb_t ui_menu_popup_cb = {
 	.close = ui_menu_popup_close,
+	.kbd = ui_menu_popup_kbd,
 	.pos = ui_menu_popup_pos
 };
@@ -72,11 +78,10 @@
 /** Create new menu.
  *
+ * @param parent Parent window
  * @param mbar Menu bar
- * @param caption Caption
  * @param rmenu Place to store pointer to new menu
  * @return EOK on success, ENOMEM if out of memory
  */
-errno_t ui_menu_create(ui_menu_bar_t *mbar, const char *caption,
-    ui_menu_t **rmenu)
+errno_t ui_menu_create(ui_window_t *parent, ui_menu_t **rmenu)
 {
 	ui_menu_t *menu;
@@ -86,12 +91,5 @@
 		return ENOMEM;
 
-	menu->caption = str_dup(caption);
-	if (menu->caption == NULL) {
-		free(menu);
-		return ENOMEM;
-	}
-
-	menu->mbar = mbar;
-	list_append(&menu->lmenus, &mbar->menus);
+	menu->parent = parent;
 	list_initialize(&menu->entries);
 
@@ -118,49 +116,18 @@
 	}
 
-	list_remove(&menu->lmenus);
 	free(menu->caption);
 	free(menu);
 }
 
-/** Get first menu in menu bar.
- *
- * @param mbar Menu bar
- * @return First menu or @c NULL if there is none
- */
-ui_menu_t *ui_menu_first(ui_menu_bar_t *mbar)
-{
-	link_t *link;
-
-	link = list_first(&mbar->menus);
-	if (link == NULL)
-		return NULL;
-
-	return list_get_instance(link, ui_menu_t, lmenus);
-}
-
-/** Get next menu in menu bar.
- *
- * @param cur Current menu
- * @return Next menu or @c NULL if @a cur is the last one
- */
-ui_menu_t *ui_menu_next(ui_menu_t *cur)
-{
-	link_t *link;
-
-	link = list_next(&cur->lmenus, &cur->mbar->menus);
-	if (link == NULL)
-		return NULL;
-
-	return list_get_instance(link, ui_menu_t, lmenus);
-}
-
-/** Get menu caption.
- *
- * @param menu Menu
- * @return Caption (owned by @a menu)
- */
-const char *ui_menu_caption(ui_menu_t *menu)
-{
-	return menu->caption;
+/** Set menu callbacks.
+ *
+ * @param menu Menu
+ * @param cb Callbacks
+ * @param arg Callback argument
+ */
+void ui_menu_set_cb(ui_menu_t *menu, ui_menu_cb_t *cb, void *arg)
+{
+	menu->cb = cb;
+	menu->arg = arg;
 }
 
@@ -174,10 +141,10 @@
     ui_menu_geom_t *geom)
 {
-	ui_resource_t *res;
 	gfx_coord2_t edim;
 	gfx_coord_t frame_w;
 	gfx_coord_t frame_h;
-
-	res = ui_window_get_res(menu->mbar->window);
+	ui_resource_t *res;
+
+	res = ui_window_get_res(menu->parent);
 
 	if (res->textmode) {
@@ -203,18 +170,4 @@
 }
 
-/** Get menu rectangle.
- *
- * @param menu Menu
- * @param spos Starting position (top-left corner)
- * @param rect Place to store menu rectangle
- */
-void ui_menu_get_rect(ui_menu_t *menu, gfx_coord2_t *spos, gfx_rect_t *rect)
-{
-	ui_menu_geom_t geom;
-
-	ui_menu_get_geom(menu, spos, &geom);
-	*rect = geom.outer_rect;
-}
-
 /** Get UI resource from menu.
  *
@@ -231,6 +184,7 @@
  * @param menu Menu
  * @param prect Parent rectangle around which the menu should be placed
- */
-errno_t ui_menu_open(ui_menu_t *menu, gfx_rect_t *prect)
+ * @param idev_id Input device associated with the menu's seat
+ */
+errno_t ui_menu_open(ui_menu_t *menu, gfx_rect_t *prect, sysarg_t idev_id)
 {
 	ui_popup_t *popup = NULL;
@@ -240,4 +194,7 @@
 	errno_t rc;
 
+	/* Select first entry */
+	menu->selected = ui_menu_entry_first(menu);
+
 	/* Determine menu dimensions */
 
@@ -249,7 +206,8 @@
 	params.rect = geom.outer_rect;
 	params.place = *prect;
-
-	rc = ui_popup_create(menu->mbar->ui, menu->mbar->window, &params,
-	    &popup);
+	params.idev_id = idev_id;
+
+	rc = ui_popup_create(ui_window_get_ui(menu->parent), menu->parent,
+	    &params, &popup);
 	if (rc != EOK)
 		return rc;
@@ -269,4 +227,14 @@
 	ui_popup_destroy(menu->popup);
 	menu->popup = NULL;
+}
+
+/** Determine if menu is open.
+ *
+ * @param menu Menu
+ * @return @c true iff menu is open
+ */
+bool ui_menu_is_open(ui_menu_t *menu)
+{
+	return menu->popup != NULL;
 }
 
@@ -439,8 +407,150 @@
 		/* Press outside menu - close it */
 		if (event->type == POS_PRESS)
-			ui_menu_bar_select(menu->mbar, NULL, NULL);
+			ui_menu_close_req(menu);
 	}
 
 	return ui_unclaimed;
+}
+
+/** Handle keyboard event in menu.
+ *
+ * @param menu Menu
+ * @param event Keyboard event
+ * @return ui_claimed iff the event was claimed
+ */
+ui_evclaim_t ui_menu_kbd_event(ui_menu_t *menu, kbd_event_t *event)
+{
+	if (event->type == KEY_PRESS && (event->mods &
+	    (KM_CTRL | KM_ALT | KM_SHIFT)) == 0) {
+		ui_menu_key_press_unmod(menu, event);
+	}
+
+	if (event->type == KEY_PRESS && (event->mods & KM_ALT) != 0 &&
+	    (event->mods & (KM_CTRL | KM_SHIFT)) == 0 && event->c != '\0')
+		ui_menu_press_accel(menu, event->c, event->kbd_id);
+
+	return ui_claimed;
+}
+
+/** Move one entry up.
+ *
+ * Non-selectable entries are skipped. If we are already at the top,
+ * we wrap around.
+ *
+ * @param menu Menu
+ */
+void ui_menu_up(ui_menu_t *menu)
+{
+	gfx_coord2_t mpos;
+	ui_menu_entry_t *nentry;
+
+	if (menu->selected == NULL)
+		return;
+
+	nentry = ui_menu_entry_prev(menu->selected);
+	if (nentry == NULL)
+		nentry = ui_menu_entry_last(menu);
+
+	/* Need to find a selectable entry */
+	while (!ui_menu_entry_selectable(nentry)) {
+		nentry = ui_menu_entry_prev(nentry);
+		if (nentry == NULL)
+			nentry = ui_menu_entry_last(menu);
+
+		/* Went completely around and found nothing? */
+		if (nentry == menu->selected)
+			return;
+	}
+
+	menu->selected = nentry;
+
+	mpos.x = 0;
+	mpos.y = 0;
+	(void) ui_menu_paint(menu, &mpos);
+}
+
+/** Move one entry down.
+ *
+ * Non-selectable entries are skipped. If we are already at the bottom,
+ * we wrap around.
+ *
+ * @param menu Menu
+ */
+void ui_menu_down(ui_menu_t *menu)
+{
+	gfx_coord2_t mpos;
+	ui_menu_entry_t *nentry;
+
+	if (menu->selected == NULL)
+		return;
+
+	nentry = ui_menu_entry_next(menu->selected);
+	if (nentry == NULL)
+		nentry = ui_menu_entry_first(menu);
+
+	/* Need to find a selectable entry */
+	while (!ui_menu_entry_selectable(nentry)) {
+		nentry = ui_menu_entry_next(nentry);
+		if (nentry == NULL)
+			nentry = ui_menu_entry_first(menu);
+
+		/* Went completely around and found nothing? */
+		if (nentry == menu->selected)
+			return;
+	}
+
+	menu->selected = nentry;
+
+	mpos.x = 0;
+	mpos.y = 0;
+	(void) ui_menu_paint(menu, &mpos);
+}
+
+/** Handle key press without modifiers in menu popup window.
+ *
+ * @param menu Menu
+ * @param event Keyboard event
+ */
+static void ui_menu_key_press_unmod(ui_menu_t *menu, kbd_event_t *event)
+{
+	ui_menu_entry_t *mentry;
+	char32_t c;
+
+	switch (event->key) {
+	case KC_ESCAPE:
+		ui_menu_close_req(menu);
+		break;
+	case KC_LEFT:
+		ui_menu_left(menu, event->kbd_id);
+		break;
+	case KC_RIGHT:
+		ui_menu_right(menu, event->kbd_id);
+		break;
+	case KC_UP:
+		ui_menu_up(menu);
+		break;
+	case KC_DOWN:
+		ui_menu_down(menu);
+		break;
+	case KC_ENTER:
+		if (menu->selected != NULL &&
+		    !ui_menu_entry_is_disabled(menu->selected))
+			ui_menu_entry_activate(menu->selected);
+		break;
+	default:
+		if (event->c != '\0') {
+			mentry = ui_menu_entry_first(menu);
+			while (mentry != NULL) {
+				c = ui_menu_entry_get_accel(mentry);
+				if (c == (char32_t)tolower(event->c) &&
+				    !ui_menu_entry_is_disabled(mentry)) {
+					ui_menu_entry_activate(mentry);
+					break;
+				}
+				mentry = ui_menu_entry_next(mentry);
+			}
+		}
+		break;
+	}
 }
 
@@ -454,6 +564,20 @@
 	ui_menu_t *menu = (ui_menu_t *)arg;
 
-	/* Close the menu */
-	ui_menu_bar_select(menu->mbar, NULL, NULL);
+	/* Forward close request to caller */
+	ui_menu_close_req(menu);
+}
+
+/** Handle keyboard event in menu popup window.
+ *
+ * @param popup Menu popup window
+ * @param arg Argument (ui_menu_t *)
+ * @param event Keyboard event
+ */
+static void ui_menu_popup_kbd(ui_popup_t *popup, void *arg, kbd_event_t *event)
+{
+	ui_menu_t *menu = (ui_menu_t *)arg;
+
+	menu->idev_id = ui_popup_get_idev_id(menu->popup);
+	ui_menu_kbd_event(menu, event);
 }
 
@@ -469,4 +593,6 @@
 	gfx_coord2_t spos;
 
+	menu->idev_id = ui_popup_get_idev_id(menu->popup);
+
 	spos.x = 0;
 	spos.y = 0;
@@ -474,4 +600,58 @@
 }
 
+/** Send menu left event.
+ *
+ * @param menu Menu
+ * @param idev_id Input device ID
+ */
+void ui_menu_left(ui_menu_t *menu, sysarg_t idev_id)
+{
+	if (menu->cb != NULL && menu->cb->left != NULL)
+		menu->cb->left(menu, menu->arg, idev_id);
+}
+
+/** Send menu right event.
+ *
+ * @param menu Menu
+ * @param idev_id Input device ID
+ */
+void ui_menu_right(ui_menu_t *menu, sysarg_t idev_id)
+{
+	if (menu->cb != NULL && menu->cb->right != NULL)
+		menu->cb->right(menu, menu->arg, idev_id);
+}
+
+/** Send menu close request event.
+ *
+ * @param menu Menu
+ */
+void ui_menu_close_req(ui_menu_t *menu)
+{
+	if (menu->cb != NULL && menu->cb->close_req != NULL)
+		menu->cb->close_req(menu, menu->arg);
+}
+
+/** Send menu accelerator key press event.
+ *
+ * @param menu Menu
+ * @param c Character
+ * @param kbd_id Keyboard ID
+ */
+void ui_menu_press_accel(ui_menu_t *menu, char32_t c, sysarg_t kbd_id)
+{
+	if (menu->cb != NULL && menu->cb->press_accel != NULL)
+		menu->cb->press_accel(menu, menu->arg, c, kbd_id);
+}
+
+/** Get ID of last device that input event.
+ *
+ * @param menu Menu
+ * @return Input device ID
+ */
+sysarg_t ui_menu_get_idev_id(ui_menu_t *menu)
+{
+	return menu->idev_id;
+}
+
 /** @}
  */
Index: uspace/lib/ui/src/menubar.c
===================================================================
--- uspace/lib/ui/src/menubar.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/menubar.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -35,4 +35,5 @@
 
 #include <adt/list.h>
+#include <ctype.h>
 #include <errno.h>
 #include <gfx/color.h>
@@ -45,9 +46,12 @@
 #include <ui/control.h>
 #include <ui/paint.h>
-#include <ui/menu.h>
 #include <ui/menubar.h>
+#include <ui/menudd.h>
+#include <ui/wdecor.h>
 #include <ui/window.h>
 #include "../private/menubar.h"
 #include "../private/resource.h"
+#include "../private/wdecor.h"
+#include "../private/window.h"
 
 enum {
@@ -60,5 +64,8 @@
 static void ui_menu_bar_ctl_destroy(void *);
 static errno_t ui_menu_bar_ctl_paint(void *);
+static ui_evclaim_t ui_menu_bar_ctl_kbd_event(void *, kbd_event_t *);
 static ui_evclaim_t ui_menu_bar_ctl_pos_event(void *, pos_event_t *);
+static void ui_menu_bar_activate_ev(ui_menu_bar_t *);
+static void ui_menu_bar_deactivate_ev(ui_menu_bar_t *);
 
 /** Menu bar control ops */
@@ -66,5 +73,6 @@
 	.destroy = ui_menu_bar_ctl_destroy,
 	.paint = ui_menu_bar_ctl_paint,
-	.pos_event = ui_menu_bar_ctl_pos_event,
+	.kbd_event = ui_menu_bar_ctl_kbd_event,
+	.pos_event = ui_menu_bar_ctl_pos_event
 };
 
@@ -93,5 +101,9 @@
 	mbar->ui = ui;
 	mbar->window = window;
-	list_initialize(&mbar->menus);
+	list_initialize(&mbar->menudds);
+
+	if (window->mbar == NULL)
+		window->mbar = mbar;
+
 	*rmbar = mbar;
 	return EOK;
@@ -104,14 +116,17 @@
 void ui_menu_bar_destroy(ui_menu_bar_t *mbar)
 {
-	ui_menu_t *menu;
+	ui_menu_dd_t *mdd;
 
 	if (mbar == NULL)
 		return;
 
-	/* Destroy menus */
-	menu = ui_menu_first(mbar);
-	while (menu != NULL) {
-		ui_menu_destroy(menu);
-		menu = ui_menu_first(mbar);
+	if (mbar->window->mbar == mbar)
+		mbar->window->mbar = NULL;
+
+	/* Destroy menu drop-downs */
+	mdd = ui_menu_dd_first(mbar);
+	while (mdd != NULL) {
+		ui_menu_dd_destroy(mdd);
+		mdd = ui_menu_dd_first(mbar);
 	}
 
@@ -120,4 +135,16 @@
 }
 
+/** Set menu bar callbacks.
+ *
+ * @param mbar Menu bar
+ * @param cb Callbacks
+ * @param arg Callback argument
+ */
+void ui_menu_bar_set_cb(ui_menu_bar_t *mbar, ui_menu_bar_cb_t *cb, void *arg)
+{
+	mbar->cb = cb;
+	mbar->arg = arg;
+}
+
 /** Get base control from menu bar.
  *
@@ -148,10 +175,10 @@
 {
 	ui_resource_t *res;
-	gfx_text_fmt_t fmt;
+	ui_text_fmt_t fmt;
 	gfx_coord2_t pos;
 	gfx_coord2_t tpos;
 	gfx_rect_t rect;
 	gfx_color_t *bg_color;
-	ui_menu_t *menu;
+	ui_menu_dd_t *mdd;
 	const char *caption;
 	gfx_coord_t width;
@@ -182,12 +209,13 @@
 	pos = mbar->rect.p0;
 
-	gfx_text_fmt_init(&fmt);
+	ui_text_fmt_init(&fmt);
+	fmt.font = res->font;
 	fmt.halign = gfx_halign_left;
 	fmt.valign = gfx_valign_top;
 
-	menu = ui_menu_first(mbar);
-	while (menu != NULL) {
-		caption = ui_menu_caption(menu);
-		width = gfx_text_width(res->font, caption) + 2 * hpad;
+	mdd = ui_menu_dd_first(mbar);
+	while (mdd != NULL) {
+		caption = ui_menu_dd_caption(mdd);
+		width = ui_text_width(res->font, caption) + 2 * hpad;
 		tpos.x = pos.x + hpad;
 		tpos.y = pos.y + vpad;
@@ -197,9 +225,11 @@
 		rect.p1.y = mbar->rect.p1.y;
 
-		if (menu == mbar->selected) {
+		if (mdd == mbar->selected) {
 			fmt.color = res->wnd_sel_text_color;
+			fmt.hgl_color = res->wnd_sel_text_hgl_color;
 			bg_color = res->wnd_sel_text_bg_color;
 		} else {
 			fmt.color = res->wnd_text_color;
+			fmt.hgl_color = res->wnd_text_hgl_color;
 			bg_color = res->wnd_face_color;
 		}
@@ -213,10 +243,10 @@
 			goto error;
 
-		rc = gfx_puttext(res->font, &tpos, &fmt, caption);
+		rc = ui_paint_text(&tpos, &fmt, caption);
 		if (rc != EOK)
 			goto error;
 
 		pos.x += width;
-		menu = ui_menu_next(menu);
+		mdd = ui_menu_dd_next(mdd);
 	}
 
@@ -236,27 +266,270 @@
  *
  * @param mbar Menu bar
- * @param rect Menu bar entry rectangle
- * @param menu Menu to select (or deselect if selected) or @c NULL
- */
-void ui_menu_bar_select(ui_menu_bar_t *mbar, gfx_rect_t *rect,
-    ui_menu_t *menu)
-{
-	ui_menu_t *old_menu;
-
-	old_menu = mbar->selected;
-
-	if (mbar->selected != menu)
-		mbar->selected = menu;
-	else
-		mbar->selected = NULL;
-
-	/* Close previously open menu */
-	if (old_menu != NULL)
-		(void) ui_menu_close(old_menu);
+ * @param mdd Menu drop-down to select (or deselect if selected) or @c NULL
+ * @param openup Open menu even if not currently open
+ * @param idev_id Input device ID associated with the selecting seat
+ */
+void ui_menu_bar_select(ui_menu_bar_t *mbar, ui_menu_dd_t *mdd, bool openup,
+    sysarg_t idev_id)
+{
+	ui_menu_dd_t *old_mdd;
+	gfx_rect_t rect;
+	bool was_open;
+
+	old_mdd = mbar->selected;
+
+	mbar->selected = mdd;
+
+	/* Close previously open menu drop-down */
+	if (old_mdd != NULL && ui_menu_dd_is_open(old_mdd)) {
+		was_open = true;
+		(void) ui_menu_dd_close(old_mdd);
+	} else {
+		was_open = false;
+	}
 
 	(void) ui_menu_bar_paint(mbar);
 
 	if (mbar->selected != NULL) {
-		(void) ui_menu_open(mbar->selected, rect);
+		ui_menu_bar_entry_rect(mbar, mbar->selected, &rect);
+		if (openup || was_open) {
+			/*
+			 * Open the newly selected menu drop-down if either
+			 * the old menu drop-down was open or @a openup was
+			 * specified.
+			 */
+			(void) ui_menu_dd_open(mbar->selected, &rect, idev_id);
+		}
+
+		if (!mbar->active)
+			ui_menu_bar_activate_ev(mbar);
+		mbar->active = true;
+	} else {
+		if (mbar->active)
+			ui_menu_bar_deactivate_ev(mbar);
+		mbar->active = false;
+	}
+}
+
+/** Select first drop-down.
+ *
+ * @param mbar Menu bar
+ * @param openup @c true to open drop-down if it was not open
+ * @param idev_id Input device ID
+ */
+void ui_menu_bar_select_first(ui_menu_bar_t *mbar, bool openup,
+    sysarg_t idev_id)
+{
+	ui_menu_dd_t *mdd;
+
+	mdd = ui_menu_dd_first(mbar);
+	ui_menu_bar_select(mbar, mdd, openup, idev_id);
+}
+
+/** Select last drop-down.
+ *
+ * @param mbar Menu bar
+ * @param openup @c true to open drop-down if it was not open
+ * @param idev_id Input device ID
+ */
+void ui_menu_bar_select_last(ui_menu_bar_t *mbar, bool openup,
+    sysarg_t idev_id)
+{
+	ui_menu_dd_t *mdd;
+
+	mdd = ui_menu_dd_last(mbar);
+	ui_menu_bar_select(mbar, mdd, openup, idev_id);
+}
+
+/** Select system menu.
+ *
+ * @param mbar Menu bar
+ * @param openup @c true to open drop-down if it was not open
+ * @param idev_id Input device ID
+ */
+void ui_menu_bar_select_sysmenu(ui_menu_bar_t *mbar, bool openup,
+    sysarg_t idev_id)
+{
+	ui_wdecor_sysmenu_hdl_set_active(mbar->window->wdecor, true);
+
+	if (openup)
+		ui_window_send_sysmenu(mbar->window, idev_id);
+}
+
+/** Move one entry left.
+ *
+ * If the selected menu is open, the newly selected menu will be open
+ * as well. If we are already at the first entry, we wrap around.
+ *
+ * @param mbar Menu bar
+ * @param idev_id Input device ID
+ */
+void ui_menu_bar_left(ui_menu_bar_t *mbar, sysarg_t idev_id)
+{
+	ui_menu_dd_t *nmdd;
+	bool sel_sysmenu = false;
+	bool was_open;
+
+	if (mbar->selected == NULL)
+		return;
+
+	nmdd = ui_menu_dd_prev(mbar->selected);
+	if (nmdd == NULL) {
+		if ((mbar->window->wdecor->style & ui_wds_sysmenu_hdl) != 0) {
+			sel_sysmenu = true;
+		} else {
+			nmdd = ui_menu_dd_last(mbar);
+		}
+	}
+
+	was_open = mbar->selected != NULL &&
+	    ui_menu_dd_is_open(mbar->selected);
+
+	if (nmdd != mbar->selected)
+		ui_menu_bar_select(mbar, nmdd, false, idev_id);
+
+	/*
+	 * Only open sysmenu *after* closing the previous menu, avoid
+	 * having multiple popup windows at the same time.
+	 */
+	if (sel_sysmenu)
+		ui_menu_bar_select_sysmenu(mbar, was_open, idev_id);
+}
+
+/** Move one entry right.
+ *
+ * If the selected menu is open, the newly selected menu will be open
+ * as well. If we are already at the last entry, we wrap around.
+ *
+ * @param mbar Menu bar
+ * @param idev_id Input device ID
+ */
+void ui_menu_bar_right(ui_menu_bar_t *mbar, sysarg_t idev_id)
+{
+	ui_menu_dd_t *nmdd;
+	bool sel_sysmenu = false;
+	bool was_open;
+
+	if (mbar->selected == NULL)
+		return;
+
+	nmdd = ui_menu_dd_next(mbar->selected);
+	if (nmdd == NULL) {
+		if ((mbar->window->wdecor->style & ui_wds_sysmenu_hdl) != 0) {
+			sel_sysmenu = true;
+		} else {
+			nmdd = ui_menu_dd_first(mbar);
+		}
+	}
+
+	was_open = mbar->selected != NULL &&
+	    ui_menu_dd_is_open(mbar->selected);
+
+	if (nmdd != mbar->selected)
+		ui_menu_bar_select(mbar, nmdd, false, idev_id);
+
+	/*
+	 * Only open sysmenu *after* closing the previous menu, avoid
+	 * having multiple popup windows at the same time.
+	 */
+	if (sel_sysmenu)
+		ui_menu_bar_select_sysmenu(mbar, was_open, idev_id);
+}
+
+/** Handle menu bar key press without modifiers.
+ *
+ * @param mbar Menu bar
+ * @param kbd_event Keyboard event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_menu_bar_key_press_unmod(ui_menu_bar_t *mbar, kbd_event_t *event)
+{
+	gfx_rect_t rect;
+
+	if (event->key == KC_F10) {
+		ui_menu_bar_activate(mbar);
+		return ui_claimed;
+	}
+
+	if (!mbar->active)
+		return ui_unclaimed;
+
+	if (event->key == KC_ESCAPE) {
+		ui_menu_bar_deactivate(mbar);
+		return ui_claimed;
+	}
+
+	if (event->key == KC_LEFT)
+		ui_menu_bar_left(mbar, event->kbd_id);
+
+	if (event->key == KC_RIGHT)
+		ui_menu_bar_right(mbar, event->kbd_id);
+
+	if (event->key == KC_ENTER || event->key == KC_DOWN) {
+		if (mbar->selected != NULL &&
+		    !ui_menu_dd_is_open(mbar->selected)) {
+			ui_menu_bar_entry_rect(mbar, mbar->selected,
+			    &rect);
+			ui_menu_dd_open(mbar->selected, &rect, event->kbd_id);
+		}
+
+		return ui_claimed;
+	}
+
+	if (event->c != '\0' && !ui_menu_dd_is_open(mbar->selected)) {
+		/* Check if it is an accelerator. */
+		ui_menu_bar_press_accel(mbar, event->c, event->kbd_id);
+	}
+
+	return ui_claimed;
+}
+
+/** Handle menu bar keyboard event.
+ *
+ * @param mbar Menu bar
+ * @param kbd_event Keyboard event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_menu_bar_kbd_event(ui_menu_bar_t *mbar, kbd_event_t *event)
+{
+	if ((event->mods & KM_ALT) != 0 &&
+	    (event->mods & (KM_CTRL | KM_SHIFT)) == 0 && event->c != '\0') {
+		/* Check if it is an accelerator. */
+		ui_menu_bar_press_accel(mbar, event->c, event->kbd_id);
+	}
+
+	if (event->type == KEY_PRESS && (event->mods &
+	    (KM_CTRL | KM_ALT | KM_SHIFT)) == 0) {
+		return ui_menu_bar_key_press_unmod(mbar, event);
+	}
+
+	if (mbar->active)
+		return ui_claimed;
+
+	return ui_unclaimed;
+}
+
+/** Accelerator key press.
+ *
+ * If @a c matches an accelerator key, open the respective menu.
+ *
+ * @param mbar Menu bar
+ * @param c Character
+ * @param kbd_id Keyboard ID
+ */
+void ui_menu_bar_press_accel(ui_menu_bar_t *mbar, char32_t c, sysarg_t kbd_id)
+{
+	ui_menu_dd_t *mdd;
+	char32_t maccel;
+
+	mdd = ui_menu_dd_first(mbar);
+	while (mdd != NULL) {
+		maccel = ui_menu_dd_get_accel(mdd);
+		if ((char32_t)tolower(c) == maccel) {
+			ui_menu_bar_select(mbar, mdd, true, kbd_id);
+			return;
+		}
+
+		mdd = ui_menu_dd_next(mdd);
 	}
 }
@@ -273,9 +546,10 @@
 	gfx_coord2_t pos;
 	gfx_rect_t rect;
-	ui_menu_t *menu;
+	ui_menu_dd_t *mdd;
 	const char *caption;
 	gfx_coord_t width;
 	gfx_coord_t hpad;
 	gfx_coord2_t ppos;
+	sysarg_t pos_id;
 
 	res = ui_window_get_res(mbar->window);
@@ -291,9 +565,10 @@
 
 	pos = mbar->rect.p0;
-
-	menu = ui_menu_first(mbar);
-	while (menu != NULL) {
-		caption = ui_menu_caption(menu);
-		width = gfx_text_width(res->font, caption) + 2 * hpad;
+	pos_id = event->pos_id;
+
+	mdd = ui_menu_dd_first(mbar);
+	while (mdd != NULL) {
+		caption = ui_menu_dd_caption(mdd);
+		width = ui_text_width(res->font, caption) + 2 * hpad;
 
 		rect.p0 = pos;
@@ -304,13 +579,94 @@
 		if (event->type == POS_PRESS &&
 		    gfx_pix_inside_rect(&ppos, &rect)) {
-			ui_menu_bar_select(mbar, &rect, menu);
+			mbar->active = true;
+
+			/* Open the menu, if not already open. */
+			if (mdd != mbar->selected)
+				ui_menu_bar_select(mbar, mdd, true, pos_id);
+
 			return ui_claimed;
 		}
 
 		pos.x += width;
-		menu = ui_menu_next(menu);
+		mdd = ui_menu_dd_next(mdd);
 	}
 
 	return ui_unclaimed;
+}
+
+/** Handle menu bar position event.
+ *
+ * @param mbar Menu bar
+ * @param mdd Menu drop-down whose entry's rectangle is to be returned
+ * @param rrect Place to store entry rectangle
+ */
+void ui_menu_bar_entry_rect(ui_menu_bar_t *mbar, ui_menu_dd_t *mdd,
+    gfx_rect_t *rrect)
+{
+	ui_resource_t *res;
+	gfx_coord2_t pos;
+	gfx_rect_t rect;
+	ui_menu_dd_t *cur;
+	const char *caption;
+	gfx_coord_t width;
+	gfx_coord_t hpad;
+
+	res = ui_window_get_res(mbar->window);
+
+	if (res->textmode) {
+		hpad = menubar_hpad_text;
+	} else {
+		hpad = menubar_hpad;
+	}
+
+	pos = mbar->rect.p0;
+
+	cur = ui_menu_dd_first(mbar);
+	while (cur != NULL) {
+		caption = ui_menu_dd_caption(cur);
+		width = ui_text_width(res->font, caption) + 2 * hpad;
+
+		rect.p0 = pos;
+		rect.p1.x = rect.p0.x + width;
+		rect.p1.y = mbar->rect.p1.y;
+
+		if (cur == mdd) {
+			*rrect = rect;
+			return;
+		}
+
+		pos.x += width;
+		cur = ui_menu_dd_next(cur);
+	}
+
+	/* We should never get here */
+	assert(false);
+}
+
+/** Activate menu bar.
+ *
+ * @param mbar Menu bar
+ */
+void ui_menu_bar_activate(ui_menu_bar_t *mbar)
+{
+	if (mbar->active)
+		return;
+
+	mbar->active = true;
+	if (mbar->selected == NULL)
+		mbar->selected = ui_menu_dd_first(mbar);
+
+	(void) ui_menu_bar_paint(mbar);
+	ui_menu_bar_activate_ev(mbar);
+}
+
+/** Deactivate menu bar.
+ *
+ * @param mbar Menu bar
+ */
+void ui_menu_bar_deactivate(ui_menu_bar_t *mbar)
+{
+	ui_menu_bar_select(mbar, NULL, false, 0);
+	ui_menu_bar_deactivate_ev(mbar);
 }
 
@@ -338,5 +694,5 @@
 }
 
-/** Handle menu bar control position event.
+/** Handle menu bar control keyboard event.
  *
  * @param arg Argument (ui_menu_bar_t *)
@@ -344,4 +700,17 @@
  * @return @c ui_claimed iff the event is claimed
  */
+ui_evclaim_t ui_menu_bar_ctl_kbd_event(void *arg, kbd_event_t *event)
+{
+	ui_menu_bar_t *mbar = (ui_menu_bar_t *) arg;
+
+	return ui_menu_bar_kbd_event(mbar, event);
+}
+
+/** Handle menu bar control position event.
+ *
+ * @param arg Argument (ui_menu_bar_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
 ui_evclaim_t ui_menu_bar_ctl_pos_event(void *arg, pos_event_t *event)
 {
@@ -351,4 +720,24 @@
 }
 
+/** Send menu bar activate event.
+ *
+ * @param mbar Menu bar
+ */
+static void ui_menu_bar_activate_ev(ui_menu_bar_t *mbar)
+{
+	if (mbar->cb != NULL && mbar->cb->activate != NULL)
+		mbar->cb->activate(mbar, mbar->arg);
+}
+
+/** Send menu bar deactivate event.
+ *
+ * @param mbar Menu bar
+ */
+static void ui_menu_bar_deactivate_ev(ui_menu_bar_t *mbar)
+{
+	if (mbar->cb != NULL && mbar->cb->deactivate != NULL)
+		mbar->cb->deactivate(mbar, mbar->arg);
+}
+
 /** @}
  */
